#1 - 11/28/2022 04:57 PM - Vladimir Tsichevski

If an unknown value is passed an an argument to a class constructor, the conversion produces an correct call.

The legacy class:

CLASS unittests.SampleClassConstructors :

    CONSTRUCTOR PUBLIC SampleClassConstructors ( arg1 AS CHARACTER,

       o1 AS Progress.Lang.Object,

       o2 AS Progress.Lang.Object):

    END.

END.

 

The test program ABLUnit:

USING OpenEdge.Core.Assert.

USING unittests.SampleClassConstructors.

ROUTINE-LEVEL ON ERROR UNDO, THROW.

CLASS unittests.TestClassConstructorObject :

  DEFINE PRIVATE VARIABLE object1 AS Progress.Lang.Object NO-UNDO.

  DEFINE PRIVATE VARIABLE object2 AS Progress.Lang.Object NO-UNDO.

  @Before.

  METHOD PUBLIC VOID BeforeClass():

     object1 = NEW Progress.Lang.Object().

     object2 = NEW Progress.Lang.Object().

  END METHOD. 

  @Test.

  METHOD PUBLIC VOID TestObject1 ():

     Assert:NotNull(NEW SampleClassConstructors("abcd", ?, object2)).

  END METHOD.

  @Test.

  METHOD PUBLIC VOID TestObject2 ():

     Assert:NotNull(NEW SampleClassConstructors("abcd", object1, ?)).

  END METHOD.

END.
The conversion result:

   @LegacySignature(type = Type.METHOD, name = "TestObject1")

   @Test

   public void testObject1()

   {

      internalProcedure(TestClassConstructorObject.class, this, "TestObject1", new Block((Body) () -> 

      {

         Assert.notNull(ObjectOps.newInstance(SampleClassConstructors.class, "III", "abcd", object2));

      }));

   }

   @LegacySignature(type = Type.METHOD, name = "TestObject2")

   @Test

   public void testObject2()

   {

      internalProcedure(TestClassConstructorObject.class, this, "TestObject2", new Block((Body) () -> 

      {

         Assert.notNull(ObjectOps.newInstance(SampleClassConstructors.class, "III", "abcd", object1));

      }));

   }

 

Note: the unknown arguments are just missing in Java calls to ObjectOps.newInstance.

#3 - 05/01/2023 09:04 AM - Constantin Asofiei

- Project changed from Conversion Tools to Base Language

#4 - 05/01/2023 09:05 AM - Constantin Asofiei

- Related to Bug #7315: unknown literal passed as an argument to a 'object' parameter added
